<?php

namespace Teknisa\FIN\Controllers;


use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Request\Row as Row;
use Teknisa\Libs\Service\CRUD as CrudService;
use Zeedhi\Framework\DTO\Request\DataSet as Data;
use Teknisa\FIN\Services\Rec01400RelatorioCustomizavelCurvaAbcClientesService;

/*
 * Class RelatorioCustomizavelCurvaABCClientesController
 * @package Teknisa\FIN\Controllers
*/
 
class Rec01400RelatorioCustomizavelCurvaAbcClientesController {
  protected $crudService;
  protected $parameterBag;
  protected $environment;
  protected $rec01400RelatorioCustomizavelCurvaAbcClientesService;
  
  
  /*
  * @param CrudService            $crudService
  * @param ParameterBag           $parameterBag
  * @param Environment            $environment
  * @param RelatorioCustomizavelCurvaAbclientesService $relatorioCustomizavelCurvaAbcClientesService
  */
   
  public function __construct(CrudService $crudService, ParameterBag $parameterBag, Environment $environment, Rec01400RelatorioCustomizavelCurvaAbcClientesService $rec01400RelatorioCustomizavelCurvaAbcClientesService){
        $this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment  = $environment;
        $this->rec01400RelatorioCustomizavelCurvaAbcClientesService = $rec01400RelatorioCustomizavelCurvaAbcClientesService;
    }
    
  public function executaProcedureCurvaAbcCliente(Row $row, Response $response) {
    try{
      // Timeout Ilimitado
      set_time_limit(0);
      
      $row  = $row->getRow();
      $parametros = $row;
      
      $buscaDadosRelatorio = $this->rec01400RelatorioCustomizavelCurvaAbcClientesService->executaProcedureCurvaAbcsClientesService($parametros);
      $response->addDataSet(new DataSet('relatorio_curva_abc_de_clientes', ['relatorio_curva_abc_de_clientes' => $buscaDadosRelatorio]));
      
    } catch (\Exception $e){
      $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
    }
  }
}